#include "pme_internalDataStructure.h"
#include "gcd_ccm.h"
extern int GCDPstep;
extern real GCDQ;
extern int GCDccindex[4];//itplzeng
int pbc_int(int i, int N)
{
	if (i >= N)
		i -= N;
	else if (i < 0)
		i += N;
	return i;
}

real ***CreateCubic_pme(int rows, int cols, int lays)
{
	int i, j;
	real ***m;
	m = (real ***)fftw_malloc(sizeof(real **) * rows);
	for (i = 0; i < rows; i++)
	{
		m[i] = (real **)fftw_malloc(sizeof(real *) * cols);
		for (j = 0; j < cols; j++)
			m[i][j] = (real *)fftw_malloc(sizeof(real) * lays);
	}
	return m;
}

real *CreateCubic2(int rows, int cols, int lays)
{
	real *m;
	m = (real *)fftw_malloc(sizeof(real) * rows * cols * lays);
	return m;
}

real *CreateMatrix2(int rows, int cols)
{
	real *m;
	m = (real *)fftw_malloc(sizeof(real) * rows * cols);
	return m;
}

real *CreateVector2(int rows)
{
	real *m;
	m = (real *)fftw_malloc(sizeof(real) * rows);
	return m;
}

double *CreateVector2Double(int rows)
{
	double *m;
	m = (double *)fftw_malloc(sizeof(double) * rows);
	return m;
}

float *CreateVector2Float(int rows)
{
	float *m;
	m = (float *)fftw_malloc(sizeof(float) * rows);
	return m;
}

int *CreateVector2Int(int rows)
{
	int *m;
	m = (int *)fftw_malloc(sizeof(int) * rows);
	return m;
}

void getChargeOfElectrode(gmx_pme_t pme, int NUserSelectGrid, double *externElectrodeCharge, real *chargeA)
{
	static double *ElectrodeCharge;
	/* itpbs 20180119, charge tune */
	static int bFirst = 1;
	int i, ii;
	static int index_current = 0;
	real nowQset;			// itplzeng
	if (bFirst)
	{
		ElectrodeCharge = CreateVector2Double(NUserSelectGrid);
		bFirst = 0;			// bug 20170214. itpbs
		char CPMtemp[36];
		int idxx;
	}
	for (i = 0; i < NUserSelectGrid; i++)
	{
		externElectrodeCharge[i] = .0;
		chargeA[i] = .0;
	}
	// itplzeng add nowQ
	nowQset = index_current % GCDPstep;
	if (nowQset < (GCDPstep / 2))
		nowQset = GCDQ * nowQset / (GCDPstep / 2);
	else
		nowQset = 2 * GCDQ - GCDQ * nowQset / (GCDPstep / 2);
	for (i = GCDccindex[0] - 1; i <= GCDccindex[1] - 1; i++)
	{
		externElectrodeCharge[i] = -1 * nowQset / (1 + GCDccindex[1] - GCDccindex[0]);
		chargeA[i] = -1 * nowQset / (1 + GCDccindex[1] - GCDccindex[0]);
	}
	for (i = GCDccindex[2] - 1; i <= GCDccindex[3] - 1; i++)
	{
		externElectrodeCharge[i] = nowQset / (1 + GCDccindex[3] - GCDccindex[2]);
		chargeA[i] = nowQset / (1 + GCDccindex[3] - GCDccindex[2]);
	}
	index_current++;
}

void force_cal_lz(gmx_pme_t pme, real *grid, pme_atomcomm_t *atc, real rcutoff, matrix box, real ewaldcoeff, int NUserSelectGrid,
			   real *UserSelectPosition, real *chargeA)
{
	static int natoms, order;
	static int nx, ny, nz, pnx, pny, pnz;
	static real spacing_x, spacing_y, spacing_z, boxX, boxY, boxZ, alpha, alpha2, alpha3, eta, eta2, eta3, rcutoff2, sqrtM_PI;
	static int bFirst = 1;

	int i, j, i0, j0, k0, pmeidx, index;
	int *idxptr;
	real qn, qelectrode, xnX, xnY, xnZ, deltaX, deltaY, deltaZ, rij, rij2, rij3, fij_r;

	if (bFirst)
	{
		printf("g_ewald = %f\n", ewaldcoeff);
		order = pme->pme_order;
		natoms = atc->n;
		nx = pme->nkx;
		ny = pme->nky;
		nz = pme->nkz;
		pnx = pme->pmegrid_nx;
		pny = pme->pmegrid_ny;
		pnz = pme->pmegrid_nz;
		spacing_x = box[XX][XX] / nx;
		spacing_y = box[YY][YY] / ny;
		spacing_z = box[ZZ][ZZ] / nz;
		boxX = box[XX][XX];
		boxY = box[YY][YY];
		boxZ = box[ZZ][ZZ];
		alpha = ewaldcoeff;
		alpha2 = alpha * alpha;
		alpha3 = alpha * alpha * alpha;
		eta = 19.79;
		eta2 = eta * eta;
		eta3 = eta * eta * eta;
		rcutoff2 = rcutoff * rcutoff;
		sqrtM_PI = sqrt(M_PI);
		bFirst = 0;
	}

	for (i = NUserSelectGrid; i < natoms; i++)
	{

		qn = atc->q[i];
		xnX = atc->x[i][XX];
		xnY = atc->x[i][YY];
		xnZ = atc->x[i][ZZ];

		if ((qn != 0))
		{
			//printf("the previous force on %d atom is x=%f\t y=%f\t z=%f\n",i,atc->f[i][XX], atc->f[i][YY], atc->f[i][ZZ]);
			for (j = 0; j < NUserSelectGrid; j++)
			{
				qelectrode = chargeA[j];
				deltaX = xnX - UserSelectPosition[3 * j];
				if (fabsf(deltaX) > (boxX / 2))
				{
					if (deltaX < 0)
						deltaX = boxX + deltaX;
					else
						deltaX = -boxX + deltaX;
				}
				deltaY = xnY - UserSelectPosition[3 * j + 1];
				if (fabsf(deltaY) > (boxY / 2))
				{
					if (deltaY < 0)
						deltaY = boxY + deltaY;
					else
						deltaY = -boxY + deltaY;
				}
				deltaZ = xnZ - UserSelectPosition[3 * j + 2];
				if (fabsf(deltaZ) > (boxZ / 2))
				{
					if (deltaZ < 0)
						deltaZ = boxZ + deltaZ;
					else
						deltaZ = -boxZ + deltaZ;
				}

				if (fabsf(deltaX) < rcutoff && fabsf(deltaY) < rcutoff && fabsf(deltaZ) < rcutoff)
				{
					rij2 = deltaX * deltaX + deltaY * deltaY + deltaZ * deltaZ;
					if (rij2 < rcutoff2)
					{
						rij = sqrt(deltaX * deltaX + deltaY * deltaY + deltaZ * deltaZ);
						rij3 = rij * rij2;
						//fij_r = ONE_4PI_EPS0/pme->epsilon_r*qn*qelectrode*(alpha3*pmecalcFSR(alpha2*rij2)-eta3*pmecalcFSR(eta2*rij2));
						fij_r = 2 * alpha * exp(-alpha2 * rij2) / (sqrtM_PI * rij2) + erfc(alpha * rij) / (rij3) - (2 * eta * exp(-eta2 * rij2) / (sqrtM_PI * rij2) + erfc(eta * rij) / (rij3));
						fij_r = ONE_4PI_EPS0 / pme->epsilon_r * qn * qelectrode * fij_r;
						atc->f[i][XX] += fij_r * deltaX;
						atc->f[i][YY] += fij_r * deltaY;
						atc->f[i][ZZ] += fij_r * deltaZ;
					}
				}
			}
			//printf("itplz the force on %d atom is x=%f\t y=%f\t z=%f\n", i, atc->f[i][XX], atc->f[i][YY], atc->f[i][ZZ]);
		}
	}
}
